#include <stdio.h>
#include <dos.h>
#include <string.h>
#include <conio.h>
#include <ctype.h>
/*#include "ansi.h"*/
#include <com.h>


void term_window(void);
void check_status(int);
void set_capture(void);
void restore_screen(void);
void change_line_settings(int);
void dial(int);
void printxy(int,int,char *);
void show_keys(void);

#define inkey() (kbhit()?getch():-1)

#define COM2            1
#define BAUD_RATE       1200
#define COM_SETTINGS    (BITS_8 | STOP_1 | NO_PARITY)

int capture = 0,
    g_echo  = 0;
FILE *capture_file;

int main(void)
{
   int     c, stop = 0;


   if(!ComStart(COM2))
   {
     printf("Error initializing com port");
     return(0);
   }
   ComSetParms(COM2, BAUD_RATE, COM_SETTINGS);



   while(!stop)
   {
       /*      If a character was recieved, print it to the console  */

       check_status(COM2);

	ComPutStr(COM2,"ARC");

       if((c=ComGetChar(COM2))!=32)
       {
	   putch(c);
	   if(capture)
	     putc(c,capture_file);
       }

   }

   ComStop(COM2);
   if(capture)
     fclose(capture_file);

   restore_screen();
   clrscr();

   return(0);
}

void check_status(int port)
{
   int x,y;
   static int cap       = -1;
   static int status    = -1;
   static int l_echo    = -1;
   char *status_strs[] = {"Offline", "Online "};
   char *cap_str[]     = {"Capture Off", "Capture On "};
   char *echo_str[]    = {"Echo Off", "Echo On "};


   if(status != ComChkCd(port))
   {
      status =  ComChkCd(port);

      x = wherex();
      y = wherey();
      window(1,1,80,25);
      textcolor(YELLOW);
      textbackground(RED);
      printxy(2,25,status_strs[status]);
      window(1,1,80,24);
      textcolor(YELLOW);
      textbackground(BLUE);
      gotoxy(x,y);
   }

   if(cap != capture)
   {
      cap = capture;

      x = wherex();
      y = wherey();
      window(1,1,80,25);
      textcolor(YELLOW);
      textbackground(RED);
      printxy(12,25,cap_str[cap]);
      window(1,1,80,24);
      textcolor(YELLOW);
      textbackground(BLUE);
      gotoxy(x,y);
   }

   if(l_echo != g_echo)
   {
      l_echo = g_echo;

      x = wherex();
      y = wherey();
      window(1,1,80,25);
      textcolor(YELLOW);
      textbackground(RED);
      printxy(69,25,echo_str[l_echo]);
      window(1,1,80,24);
      textcolor(YELLOW);
      textbackground(BLUE);
      gotoxy(x,y);
   }
}

void restore_screen(void)
{
   window(1,1,80,25);
   clrscr();
}

void printxy(int x, int y, char *string)
{
   int l,r;

   l = wherex();
   r = wherey();
   
   gotoxy(x,y);
   cprintf(string);

   gotoxy(l,r);
}
