#include "c:\cryo\2g\include.inc"
#include "c:\cryo\2g\def.inc"
#include "c:\cryo\2g\typ.inc"
#include "c:\cryo\2g\global.inc"
#include "c:\cryo\2g\proto.inc"


main (void)
{
      char          daten[10];
	double xx,yy,zz;
      int           i, crc;

/*	Befehle fr sie serielle Schnittstelle (INT 14H):
	Register AH:
      ------------------
		 -->	 00H = Initialisierung
				Register AL = Konfigurationsparameter
                        	Bits 0-1: Datenlnge
                              		10b = 7 bits
                                          11b = 8 bits
                              Bit 2   : Stopbits
                              		0b = 1 Stopbit
                                          1b = 1.5 od. 2 Stopbits (je nach Baudrate)
                              Bits 3-4: Paritt
                              		00b = keine (NONE)
                                          01b = ungerade (ODD)
                                          11b = gerade (EVEN)
                              Bits 5-7: Baudrate
                              		000b = 110 Bd
                                          001b = 150 Bd
                                          010b = 300 Bd
                                          011b = 600 Bd
                                          100b = 1200 Bd
                                          101b = 2400 Bd
                                          110b = 4800 Bd
                                          111b = 9600 Bd
                        Rckgabewert:
                        AH: Status der ser. Schnittstelle
				Bit gesetzt  |    Bedeutung
                        	0	      Daten stehen bereit
					1		berlauf
					2		Parittsfehler
					3		Protokoll nicht eingehalten
					4		Unterbrechung entdeckt
					5		Transmission-Hold-Register leer
					6		Transmission-Shift-Register leer
					7		Time Out
                        AL: Modemstatus
				Bit gesetzt  |    Bedeutung
                        	0	      (Delta)Modem zum Senden bereit
					1		(Delta)Modem ist angeschaltet
					2		(Delta)Telefon lutet
					3		(Delta)Verbindung zum Empf.-Modem aufgebaut
					4		Modem zum Senden bereit
					5		Modem ist angeschaltet
					6		Telefon lutet
					7		Verbindung zum Empfnger-Modem aufgebaut
	------------------
      	 -->	 01H = Zeichen ausgeben
                   	Register AL = auszugebendes Zeichen
                        Rckgabewert:
                        AH: Bit 7 = 0: Zeichen wurde bertragen
                            Bit 7 = 1: Fehler; Status in Bits 0-6:
                            	Bit gesetzt  |    Bedeutung
                        	     0	      Daten stehen bereit
					     1		berlauf
					     2		Parittsfehler
					     3		Protokoll nicht eingehalten
					     4		Unterbrechung entdeckt
					     5		Transmission-Hold-Register leer
					     6		Transmission-Shift-Register leer
      ------------------
             -->   02H = Zeichen einlesen
                        Rckgabewert:
                        AH: Bit 7 = 0: Zeichen wurde empfangen,
                        		   AL = Zeichen
                            Bit 7 = 1: Fehler; Status in Bits 0-6:
                            	Bit gesetzt  |    Bedeutung
                        	     0	      Daten stehen bereit
					     1		berlauf
					     2		Parittsfehler
					     3		Protokoll nicht eingehalten
					     4		Unterbrechung entdeckt
					     5		Transmission-Hold-Register leer
					     6		Transmission-Shift-Register leer
      ------------------
             -->   03H = Status erfragen
      			Rckgabewert:
                        AH: Status der ser. Schnittstelle
				Bit gesetzt  |    Bedeutung
                        	0	      Daten stehen bereit
					1		berlauf
					2		Parittsfehler
					3		Protokoll nicht eingehalten
					4		Unterbrechung entdeckt
					5		Transmission-Hold-Register leer
					6		Transmission-Shift-Register leer
					7		Time Out
                        AL: Modemstatus
				Bit gesetzt  |    Bedeutung
                        	0	      (Delta)Modem zum Senden bereit
					1		(Delta)Modem ist angeschaltet
					2		(Delta)Telefon lutet
					3		(Delta)Verbindung zum Empf.-Modem aufgebaut
					4		Modem zum Senden bereit
					5		Modem ist angeschaltet
					6		Telefon lutet
					7		Verbindung zum Empfnger-Modem aufgebaut
      --------------------------------------------------
      Register DX: 0000H = COM1:
      		 0001H = COM2: etc.

*/


	/* Initialisierung von COM2: mit D8,S1,PN,B1200*/
      oreg.h.ah = 0x00;
      oreg.h.al = 0x83;
      oreg.x.dx = 0x0001;
      int86(0x14,&oreg,&ireg);

      send_more(2,"ACR",3);
      send_more(2,"ACFT",4);
      send_more(2,"ACR1",4);
      send_more(2,"ACSE",4);
      send_more(2,"ACLC",4);

      send_more(2,"ALD",3);
      send_more(2,"XSD",3);
	get_more(2,daten);
	xx = atof(daten);
      send_more(2,"YSD",3);
	get_more(2,daten);
	yy = atof(daten);
      send_more(2,"ZSD",3);
	get_more(2,daten);
	zz = atof(daten);

	return (0);
}

int   send(int com, char al)
{     if (BF.a) return(al);
	oreg.h.ah = 0x01;
      oreg.h.al = al;
      oreg.x.dx = 0x0001;
      if (!TEST)
	int86(0x14,&oreg,&ireg);
      if (ireg.h.ah >= 0x80) break_point();
      return(ireg.h.al);
}

int	get1(int com)
{     if (BF.a) return(33);
	oreg.h.ah = 0x02;
	oreg.x.dx = 0x0001;
	if (!TEST) int86(0x14,&oreg,&ireg);
      return(ireg.x.ax);
}

int	send_more(int com, char *c, int l)
{	int	         i;
      unsigned       ui;
      char           dummy[20], ok;

      if (BF.a) return(l);
/*	 Initialisierung von COM2: mit D8,S1,PN,B1200*/
      oreg.h.ah = 0x00;
      oreg.h.al = 0x83;
      oreg.x.dx = 0x0001;
      int86(0x14,&oreg,&ireg);
	for (i=0;i<l;i++)
		if (c[i] != send(com,c[i])) break_point();;
      return(0);
}

int	get_more(int com, char *c)
{	int	i, in, j;

	if (BF.c)
      {
      	return(0);
      }
	if (!TEST)
	{     i = j = in = 1;
            while(j)
	      {     if (in == ETX) j--;
		      in = get1(com);
		      if (!(in&0x8000))
		      {	*(c+i) = in%256;
      		      i++;
	            }
                  else g_error++;
                  if (BF.a && (i==5)) j--;
                  if (g_error) return(-1);
            }
            *c = (char)i;
      }
      else strcpy(c,"TEST");
      return(1);
}

int   cs(char *c,int l1, int l2)
{     int     i, chks;

      chks = c[l1];
      for (i=l1+1;i<l2;i++) chks ^= c[i];
      return(chks);
}


int	crc(char *c, int l)
{	int	cs, i, b;

	b = 1;
	i = strlen(c);
      cs = *(c+b);

	while (++b < l)
		cs ^= *(c+b);
      return(cs);
}

int break_point(void)
{
	delay(1000);
}
